<!doctype html>
<html lang="ja">

<head>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@exampledev/new.css@1.1.2/new.min.css">
    <script src="https://cdn.jsdelivr.net/npm/vue@2.6.12/dist/vue.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
    <style>
        ::selection {
            background: #e3e3e3;
            color: #000;
        }
    </style>
</head>

<body>
    <h1>グループの編集</h1>
    <div id="app">
        <p>グループの名前です。20文字以内で入力してください。<br />
            <input type="text" v-model="name" placeholder="名前" v-on:change="val('name', /.{1,20}/)" />{{nameVal}}
        </p>
        <p v-if="!alreadyPremium">
            <label>
                <input type="checkbox" v-model="premium" />
                <img src="https://media.thedesk.top/free/kukaibotpremium.svg" style="height: 1rem; margin-bottom: -2px"
                    alt="句会botプレミアム">(有料)
            </label>
        </p>
        <p v-else>
            既に<img src="https://media.thedesk.top/free/kukaibotpremium.svg" style="height: 1rem; margin-bottom: -2px"
                alt="句会botプレミアム">グループです。
        </p>
        <div v-if="premium">
            一回払い 500円<br />
            <div id="card" class="payjs-outer" style="width: 400px"></div>
            <p v-if="!init">カード情報は全て
                <a href="https://pay.jp" target="_blank">pay.jp</a>
                が処理します。開発側に渡ることはありません。
            </p>
            <button onclick="cardInit(event)" v-if="!init">カード情報を入力</button>
            <button onclick="onSubmit(event)" v-if="init && !validCard">カードを検証</button>
            <p v-if="validCard">カードの検証が完了しました</p>
            <input type="hidden" id="cardToken" v-model="token" />

        </div>
        <br />
        <input type="hidden" id="code" v-model="code" />
        <button v-on:click="edit()" :disabled="(premium && !validCard) || completed" v-if="admin">変更する</button>
        <template v-else>管理者の人が情報を変更できます。</template>
    </div>
    <br />
    <img src="https://media.thedesk.top/free/kukaibotpremium.svg" style="height: 50px" alt="句会botプレミアム">
    <p>句会の上限参加人数が20人から無制限に！</p>
    <p>自動締め切り機能が使える！</p>
    <h3>一度きり500円のお支払いでご利用可能です。</h3>
    <p>18歳未満(18歳の高校生含む)の生徒が代表を務める団体(学校の部活動など)に対しては無料で提供します。
        p@cutls.com までご連絡ください。
    </p>
    <script src="https://js.pay.jp/v2/pay.js"></script>
    <script>
        var vm = new Vue({
            el: '#app',
            data: {
                name: null,
                nameVal: null,
                premium: false,
                alreadyPremium: true,
                init: false,
                validCard: false,
                token: null,
                admin: false,
                code: null,
                completed: false
            },
            methods: {
                window: onload = async function () {
                    const obj = location.search.substring(1).split('&').map((p) => p.split('=')).reduce((obj, e) => ({ ...obj, [e[0]]: e[1] }), {})
                    const data = await axios.post(`/v1/settings`, {
                        authMethod: 'code',
                        group: obj.group,
                        code: obj.code
                    })
                    vm.name = data.data.name
                    vm.alreadyPremium = data.data.premium
                    vm.admin = data.data.admin
                },
                val: function (target, pattern) {
                    if (!this[target].match(pattern)) return false
                    if (this[target].match(pattern)[0] !== this[target]) {
                        this[`${target}Val`] = '正しい値で入力してください。'
                        return false
                    }
                    return true
                },
                edit: async function () {
                    let error = false
                    const obj = location.search.substring(1).split('&').map((p) => p.split('=')).reduce((obj, e) => ({ ...obj, [e[0]]: e[1] }), {})
                    if (!obj.code) error = true
                    if (!this.val('name', /.{1,20}/)) error = true
                    if (error) {
                        alert('正しい形式で入力してください。')
                        return false
                    }
                    const data = await axios.post(`/v1/setting/web`, {
                        token: this.premium ? this.token : null,
                        name: this.name,
                        group: obj.group,
                        code: obj.code
                    })
                    if (data.data.status) {
                        alert(data.data.status)
                        this.validCard = false
                        return false
                    }
                    this.completed = true
                    if (confirm('編集が完了しました。Web版をご利用の場合は"OK"を押すことでWeb版に飛びます')) {
                        location.href = 'https://kukaibot-web.0px.io'
                    } else {
                        alert('このままアプリに戻ってください。')
                    }
                }
            }
        })
    </script>
    <script>
        var payjp = Payjp('%pay%')
        var cardElement
        function cardInit() {
            vm.init = true
            var elements = payjp.elements()
            cardElement = elements.create('card')
            cardElement.mount('#card')
        }
        function onSubmit(event) {
            payjp.createToken(cardElement).then(function (r) {
                if (r.error) alert(r.error.message)
                vm.token = r.id
                vm.validCard = r.error ? false : true
            })
        }
    </script>
</body>

</html>